VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Reversi (www.Sefro1.Blogfa.com)"
   ClientHeight    =   4215
   ClientLeft      =   4950
   ClientTop       =   3615
   ClientWidth     =   4815
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   281
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   321
   Begin VB.CommandButton cmdButton 
      Height          =   195
      Index           =   0
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Green:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   178
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   3000
      TabIndex        =   4
      Top             =   3720
      Width           =   960
   End
   Begin VB.Label lblGreen 
      AutoSize        =   -1  'True
      Caption         =   "2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   178
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   4080
      TabIndex        =   3
      Top             =   3720
      Width           =   165
   End
   Begin VB.Label lblRed 
      AutoSize        =   -1  'True
      Caption         =   "2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   178
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1200
      TabIndex        =   2
      Top             =   3720
      Width           =   165
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Red:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   178
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   480
      TabIndex        =   1
      Top             =   3720
      Width           =   660
   End
   Begin VB.Menu mnuNew 
      Caption         =   "New"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'0       0 0 0 0  0     0  0 0 0   0 0 0   0 0 0   0  0  0
' 0     0  0    0  0   0  0     0  0      0        0 0
'  0   0   0 0 0    0 0   0     0  0 0 0   0 0 0   00    0
'   0 0    0    0    0    0     0  0            0  0 0   0
'    0     0 0 0     0     0 0 0   0       0 0 0   0  0  0
'
'************* Maked By:   Masoud Dehghanpour *************
'*************  0912-7968743 Or 0936-9210778  *************

Option Explicit

Private Enum PLAYCNT
    Play = 0
    PointsCounter = 1
End Enum

Private Enum PLAYCNT_COLOR
    Red = 0
    Green = 1
End Enum

Dim Shift As Boolean
Dim MainIndex As Integer, OldIndex As Integer
Dim RedPoints As Integer, GreenPoints As Integer
Dim CUp As Boolean, CDown As Boolean
Dim CLeft As Boolean, CRight As Boolean
Dim Points()

Private Sub cmdButton_Click(Index As Integer)
    If cmdButton(Index).BackColor = vbGreen Or cmdButton(Index).BackColor = vbRed Then Exit Sub
    
    If Shift = False Then
        If Play_CNT(Index, Green, PointsCounter) <= 0 Then Exit Sub
        Play_CNT Index, Green, Play
    Else
        If Play_CNT(Index, Red, PointsCounter) <= 0 Then Exit Sub
        Play_CNT Index, Red, Play
    End If
    Shift = Not Shift
    If Shift Then Call CPUPoints(vbRed)
End Sub

Private Sub cmdButton_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    cmdButton(Index).ToolTipText = Index
End Sub

Private Sub Form_Load()
    Dim i As Byte, k As Byte
    Dim Index As Integer, cmdTop As Integer, cmdLeft As Integer
    
    Me.Hide
    Index = 0
    cmdTop = cmdButton(Index).Top

    For i = 1 To 18
        cmdLeft = cmdButton(0).Left
        For k = 1 To 18
            Index = Index + 1
            Load cmdButton(Index)
            cmdButton(Index).Left = cmdLeft
            cmdButton(Index).Top = cmdTop
            cmdButton(Index).Visible = True
            cmdButton(Index).Tag = Index
            
            If i = 9 And k = 9 Then
                cmdButton(Index).BackColor = vbRed
            ElseIf i = 9 And k = 10 Then
                cmdButton(Index).BackColor = vbGreen
            ElseIf i = 10 And k = 9 Then
                cmdButton(Index).BackColor = vbGreen
            ElseIf i = 10 And k = 10 Then
                cmdButton(Index).BackColor = vbRed
            End If
            cmdLeft = cmdButton(Index).Left + cmdButton(Index).Width
        Next k
        cmdTop = cmdButton(Index).Top + cmdButton(Index).Height
    Next i
    
    RedPoints = 2: GreenPoints = 2
    Me.Show
End Sub

Private Sub mnuNew_Click()
    Dim i As Byte, k As Byte
    Dim Index As Integer
    
    Me.Hide
    Index = 0

    For i = 1 To 18
        For k = 1 To 18
            Index = Index + 1
            cmdButton(Index).BackColor = vbButtonFace
            If i = 9 And k = 9 Then
                cmdButton(Index).BackColor = vbRed
            ElseIf i = 9 And k = 10 Then
                cmdButton(Index).BackColor = vbGreen
            ElseIf i = 10 And k = 9 Then
                cmdButton(Index).BackColor = vbGreen
            ElseIf i = 10 And k = 10 Then
                cmdButton(Index).BackColor = vbRed
            End If
        Next k
    Next i
    
    RedPoints = 2: GreenPoints = 2
    lblRed = RedPoints: lblGreen = GreenPoints
    Command1.BackColor = vbGreen
    Shift = False
    Me.Show
End Sub

Public Sub CheckRand(Index As Integer)
    Dim i As Integer
    
    If Index / 18 <= 1 Then CUp = False Else CUp = True
    If Index >= 307 And Index <= 324 Then CDown = False Else CDown = True
    
    If Index < 1 Then CLeft = False: GoTo Right
    For i = 1 To 307 Step 18
        If Index = i Then
            CLeft = False
            Exit For
        Else
            CLeft = True
        End If
    Next i

Right:
    If Index > 324 Then CRight = False: Exit Sub
    For i = 18 To 324 Step 18
        If Index = i Then
            CRight = False
            Exit For
        Else
            CRight = True
        End If
    Next i
    
    'pUp = CUp: pDown = CDown: pLeft = CLeft: pRight = CRight
End Sub

Private Function Play_CNT(Index As Integer, cmdColor As PLAYCNT_COLOR, Shift As PLAYCNT) As Integer
    Dim Color As Long, Color2 As Long, selColor As Long
    Dim Index2 As Integer
    Dim CHK As Boolean
    Dim i As Integer, CNT As Integer
    
    If cmdColor = Green Then
        Color = vbGreen: Color2 = vbRed
    Else
        Color = vbRed: Color2 = vbGreen
    End If
    
    If Shift = Play Then cmdButton(Index).BackColor = Color
    selColor = Color
    
    Index2 = Index
    Call CheckRand(Index)
    Do While CUp = True
        Index2 = Index2 - 18
        If Index2 <= 0 Then Exit Do
        selColor = cmdButton(Index2).BackColor
        If selColor = Color2 Then CHK = True
        If CHK = True And selColor = Color Then
            CUp = False
            For i = Index2 + 18 To Index - 18 Step 18
                If Shift = Play Then cmdButton(i).BackColor = Color
                CNT = CNT + 1
            Next i
        End If
        If selColor = vbButtonFace Then CUp = False
        If selColor = Color And CHK = False Then CUp = False
    Loop
    
    CHK = False
    Index2 = Index
    Call CheckRand(Index)
    Do While CDown = True
        Index2 = Index2 + 18
        If Index2 > 324 Then Exit Do
        selColor = cmdButton(Index2).BackColor
        If selColor = Color2 Then CHK = True
        If CHK = True And selColor = Color Then
            CDown = False
            For i = Index + 18 To Index2 - 18 Step 18
                If Shift = Play Then cmdButton(i).BackColor = Color
                CNT = CNT + 1
            Next i
        End If
        If selColor = vbButtonFace Then CDown = False
        If selColor = Color And CHK = False Then CDown = False
    Loop
    
    CHK = False
    Index2 = Index
    Call CheckRand(Index)
    Do While CLeft = True
        Index2 = Index2 - 1
        selColor = cmdButton(Index2).BackColor
        If selColor = Color2 Then CHK = True
        If CHK = True And selColor = Color Then
            CLeft = False
            For i = Index2 + 1 To Index - 1
                If Shift = Play Then cmdButton(i).BackColor = Color
                CNT = CNT + 1
            Next i
        End If
        If selColor = vbButtonFace Then CLeft = False
        If selColor = Color And CHK = False Then CLeft = False
    Loop
    
    CHK = False
    Index2 = Index
    Call CheckRand(Index)
    Do While CRight = True
        Index2 = Index2 + 1
        selColor = cmdButton(Index2).BackColor
        If selColor = Color2 Then CHK = True
        If CHK = True And selColor = Color Then
            CRight = False
            For i = Index + 1 To Index2 - 1
                If Shift = Play Then cmdButton(i).BackColor = Color
                CNT = CNT + 1
            Next i
        End If
        If selColor = vbButtonFace Then CRight = False
        If selColor = Color And CHK = False Then CRight = False
    Loop
    
    Play_CNT = CNT
    If Shift = PointsCounter Then Exit Function
    
    lblRed = Color_CNT(vbRed): lblGreen = Color_CNT(vbGreen)
End Function

'*************************************
'*************************************
'********* COMPUTER PROCESS **********
'*************************************
'*************************************

Private Sub CPUPoints(Color As Long)
    Dim i As Integer, k As Integer
    Dim Flag As Byte, CNT As Byte
    Dim Temp As Integer
    Dim Count()
    
    ReDim Points(0)
    ReDim Count(0)
    
    For i = 1 To 324
        If cmdButton(i).BackColor = Color Then
            ReDim Preserve Points(CNT)
            Points(CNT) = i
            CNT = CNT + 1
        End If
    Next i
    
    ReDim Count(0 To UBound(Points))
    For i = LBound(Points) To UBound(Points)
        Count(i) = Play_CNT(CInt(Points(i)), Red, PointsCounter)
    Next i
    
    For i = 0 To UBound(Count) - 1
        Flag = i
        For k = i To UBound(Count) - 1
            If Count(Flag) > Count(k) Then Flag = k
        Next k
        If Flag <> i Then
            Temp = Count(Flag)
            Count(Flag) = Count(i)
            Count(i) = Temp
            
            Temp = Points(Flag)
            Points(Flag) = Points(i)
            Points(i) = Temp
        End If
    Next i
    
    Call cmdButton_Click(NewIndex(CInt(Points(0)), vbRed))
End Sub

Private Function NewIndex(OldIndex As Integer, Color As Long) As Integer
    Dim Color2 As Long, selColor As Long
    Dim Index As Integer, Index2 As Integer
    Dim Index3 As Integer, Index4 As Integer
    Dim CHK As Boolean
    Dim i As Integer, CNT(1 To 4) As Integer
    Dim MAX As Byte, MAX_CNT As Byte
    Dim Cont As Byte
    
    If Color = vbRed Then Color2 = vbGreen Else Color2 = vbRed
    
    selColor = Color
    
First:
    Index = OldIndex
    Call CheckRand(OldIndex)
    Do While CUp = True
        Index = Index - 18
        If Index <= 0 Then Exit Do
        selColor = cmdButton(Index).BackColor
        If selColor = Color2 Then CHK = True
        If selColor = vbButtonFace And CHK = False Then Exit Do
        If selColor = Color Then Exit Do
        If CHK = True And selColor = vbButtonFace Then
            CUp = False: CHK = False
            For i = Index + 18 To OldIndex - 18 Step 18
                CNT(1) = CNT(1) + 1: Next i
        End If
    Loop
    
    CHK = False
    Index2 = OldIndex
    Call CheckRand(OldIndex)
    Do While CDown = True
        Index2 = Index2 + 18
        If Index2 > 324 Then Exit Do
        selColor = cmdButton(Index2).BackColor
        If selColor = Color2 Then CHK = True
        If selColor = vbButtonFace And CHK = False Then Exit Do
        If selColor = Color Then Exit Do
        If CHK = True And selColor = vbButtonFace Then
            CDown = False: CHK = False
            For i = OldIndex + 18 To Index2 - 18 Step 18
                CNT(2) = CNT(2) + 1: Next i
        End If
    Loop
    
    CHK = False
    Index3 = OldIndex
    Call CheckRand(OldIndex)
    Do While CLeft = True
        Index3 = Index3 - 1
        selColor = cmdButton(Index3).BackColor
        If selColor = Color2 Then CHK = True
        If selColor = vbButtonFace And CHK = False Then Exit Do
        If selColor = Color Then Exit Do
        If CHK = True And selColor = vbButtonFace Then
            CLeft = False: CHK = False
            For i = Index3 + 1 To OldIndex - 1
                CNT(3) = CNT(3) + 1: Next i
        End If
    Loop
    
    CHK = False
    Index4 = OldIndex
    Call CheckRand(OldIndex)
    Do While CRight = True
        Index4 = Index4 + 1
        selColor = cmdButton(Index4).BackColor
        If selColor = Color2 Then CHK = True
        If selColor = vbButtonFace And CHK = False Then Exit Do
        If selColor = Color Then Exit Do
        If CHK = True And selColor = vbButtonFace Then
            CRight = False: CHK = False
            For i = OldIndex + 1 To Index4 - 1
                CNT(4) = CNT(4) + 1: Next i
        End If
    Loop
    
    For i = 1 To 4
        If CNT(i) > MAX_CNT Then
            MAX = i
            MAX_CNT = CNT(i)
        End If
    Next i
    
    If MAX_CNT = 0 Then
        Cont = Cont + 1
        If Cont > UBound(Points) Then MsgBox Empty: Exit Function
        OldIndex = Points(Cont)
        GoTo First:
    ElseIf MAX = 1 Then
        NewIndex = Index
    ElseIf MAX = 2 Then
        NewIndex = Index2
    ElseIf MAX = 3 Then
        NewIndex = Index3
    ElseIf MAX = 4 Then
        NewIndex = Index4
    End If
End Function

Private Function Color_CNT(Color As Long) As Integer
    Dim i As Integer
    
    For i = 1 To 324
        If cmdButton(i).BackColor = Color Then Color_CNT = Color_CNT + 1
    Next i
End Function
